Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.core.env
Class PropertySource<T>

    java.lang.Object
      org.springframework.core.env.PropertySource<T>

Direct Known Subclasses:
  CommandLinePropertySource, CompositePropertySource, EnumerablePropertySource, JndiPropertySource, PropertySource.StubPropertySource

    public abstract class PropertySource<T>

extends java.lang.Object

Abstract base class representing a source of name/value property pairs. The underlying source object may be of any type `T` that encapsulates properties. Examples include `Properties` objects, `Map` objects, `ServletContext` and `ServletConfig` objects (for access to init parameters). Explore the `PropertySource` type hierarchy to see provided implementations.

`PropertySource` objects are not typically used in isolation, but rather through a `PropertySources` object, which aggregates property sources and in conjunction with a `PropertyResolver` implementation that can perform precedence-based searches across the set of `PropertySources`.

`PropertySource` identity is determined not based on the content of encapsulated properties, but rather based on the `name` of the `PropertySource` alone. This is useful for manipulating `PropertySource` objects when in collection contexts. See operations in `MutablePropertySources` as well as the `named(String)` and `toString()` methods for details.

Note that when working with @`Configuration` classes that the @`PropertySource` annotation provides a convenient and declarative way of adding property sources to the enclosing `Environment`.

Since:
  3.1
Author:
  Chris Beams
See Also:
  `PropertySources`, `PropertyResolver`, `PropertySourcesPropertyResolver`, `MutablePropertySources`, `PropertySource`

Nested Class Summary
`static class` | `PropertySource.StubPropertySource` `PropertySource` to be used as a placeholder in cases where an actual property source cannot be eagerly initialized at application context creation time.

Field Summary
`protected org.apache.commons.logging.Log` | `logger`
`protected java.lang.String` | `name`
`protected T` | `source`

Constructor Summary
`PropertySource(java.lang.String name)` Create a new `PropertySource` with the given name and with a new `Object` instance as the underlying source.
`PropertySource(java.lang.String name, T source)` Create a new `PropertySource` with the given name and source object.

Method Summary
`boolean` | `containsProperty(java.lang.String name)` Return whether this `PropertySource` contains the given name.
`boolean` | `equals(java.lang.Object obj)` This `PropertySource` object is equal to the given object if: they are the same instance the `name` properties for both objects are equal
`java.lang.String` | `getName()` Return the name of this `PropertySource`
`abstract java.lang.Object` | `getProperty(java.lang.String name)` Return the value associated with the given name, `null` if not found.
`T` | `getSource()` Return the underlying source object for this `PropertySource`.
`int` | `hashCode()` Return a hashcode derived from the `name` property of this `PropertySource` object.
`static PropertySource<?>` | `named(java.lang.String name)` Return a `PropertySource` implementation intended for collection comparison purposes only.
`java.lang.String` | `toString()` Produce concise output (type and name) if the current log level does not include debug.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### logger

    protected final org.apache.commons.logging.Log logger

### name

    protected final java.lang.String name

### source

    protected final T source

Constructor Detail

### PropertySource

    public PropertySource(java.lang.String name,
                          T source)

  Create a new `PropertySource` with the given name and source object.

### PropertySource

    public PropertySource(java.lang.String name)

  Create a new `PropertySource` with the given name and with a new `Object` instance as the underlying source.

  Often useful in testing scenarios when creating anonymous implementations that never query an actual source, but rather return hard-coded values.

Method Detail

### getName

    public java.lang.String getName()

  Return the name of this `PropertySource`

### getSource

    public T getSource()

  Return the underlying source object for this `PropertySource`.

### containsProperty

    public boolean containsProperty(java.lang.String name)

  Return whether this `PropertySource` contains the given name.

  This implementation simply checks for a null return value from `getProperty(String)`. Subclasses may wish to implement a more efficient algorithm if possible.

  Parameters:
    `name` - the property name to find

### getProperty

    public abstract java.lang.Object getProperty(java.lang.String name)

  Return the value associated with the given name, `null` if not found.

  Parameters:
    `name` - the property to find
  See Also:
    `PropertyResolver.getRequiredProperty(String)`

### hashCode

    public int hashCode()

  Return a hashcode derived from the `name` property of this `PropertySource` object.

  Overrides:
    `hashCode` in class `java.lang.Object`

### equals

    public boolean equals(java.lang.Object obj)

  This `PropertySource` object is equal to the given object if:
  - they are the same instance
  - the `name` properties for both objects are equal

  No properties other than `name` are evaluated.

  Overrides:
    `equals` in class `java.lang.Object`

### toString

    public java.lang.String toString()

  Produce concise output (type and name) if the current log level does not include debug. If debug is enabled, produce verbose output including hashcode of the PropertySource instance and every name/value property pair. This variable verbosity is useful as a property source such as system properties or environment variables may contain an arbitrary number of property pairs, potentially leading to difficult to read exception and log messages.

  Overrides:
    `toString` in class `java.lang.Object`
  See Also:
    `Log.isDebugEnabled()`

### named

    public static PropertySource<?> named(java.lang.String name)

  Return a `PropertySource` implementation intended for collection comparison purposes only.

  Primarily for internal use, but given a collection of `PropertySource` objects, may be used as follows:

       List<PropertySource<?>> sources = new ArrayList<PropertySource<?>>();
       sources.add(new MapPropertySource("sourceA", mapA));
       sources.add(new MapPropertySource("sourceB", mapB));
       assert sources.contains(PropertySource.named("sourceA"));
       assert sources.contains(PropertySource.named("sourceB"));
       assert !sources.contains(PropertySource.named("sourceC"));

  The returned `PropertySource` will throw `UnsupportedOperationException` if any methods other than `equals(Object)`, `hashCode()`, and `toString()` are called.

  Parameters:
    `name` - the name of the comparison `PropertySource` to be created and returned.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD